﻿Imports System.Data
Imports Infragistics.Web.UI.GridControls

Partial Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, args As EventArgs) Handles Me.Load
        ConfigureDataSource()
    End Sub

    Protected Overrides Sub OnInit(e As EventArgs)
        MyBase.OnInit(e)

        AddHandler Me.WebHierarchicalDataGrid1.RowIslandsPopulating, AddressOf WebHierarchicalDataGrid1_RowIslandsPopulating

        If Session("DataSet") Is Nothing Then
            Dim repository = New Repository()
            Session("DataSet") = repository.DataSet
        End If

        Me.WebHierarchicalDataGrid1.DataSource = Session("DataSet")
    End Sub

    Sub WebHierarchicalDataGrid1_RowIslandsPopulating(sender As Object, e As ContainerRowCancelEventArgs)
        e.Cancel = True

        Dim dataSet = TryCast(Session("DataSet"), DataSet)

        Dim childTable As DataTable

        Select Case e.Row.Level
            Case 0
                childTable = dataSet.Tables("ChildTable1")
            Case 1
                childTable = dataSet.Tables("ChildTable2")
            Case 2
                childTable = dataSet.Tables("ChildTable3")
        End Select

        Dim childGrid As New ContainerGrid()

        childGrid.DataKeyFields = childTable.PrimaryKey(0).ColumnName
        e.Row.RowIslands.Add(childGrid)
        childGrid.Level = e.Row.Level + 1
        childGrid.DataSource = childTable
        childGrid.DataBind()

        If (e.Row.Level <> 2) Then

            For Each row As ContainerGridRecord In childGrid.Rows
                If childTable.Rows.Item(row.Index).GetChildRows(childTable.ChildRelations(0)).Any() Then
                    row.IsEmptyParent = True
                End If
            Next

        End If
    End Sub

    Private Sub ConfigureDataSource()
        If Not IsPostBack Then
            Me.WebHierarchicalDataGrid1.DataBind()
        End If
    End Sub
End Class
