﻿
Imports System.Collections.Generic
Imports System.Data
Imports System.Linq

Public Class Repository
	Private Shared randomGenerator As New Random()

	Public Sub New()
		Me.DataSet = New DataSet()

		Dim parentTable = Me.CreateTable("ParentTable")
		Me.DataSet.Tables.Add(parentTable)

		Dim childTable1 = Me.CreateTable("ChildTable1", "ForeignKey", Me.GetParentIds(parentTable))
        Me.DataSet.Tables.Add(childTable1)
		Me.DataSet.Relations.Add(New DataRelation("Parent-Child1", parentTable.Columns("Id"), childTable1.Columns("ForeignKey")))

		Dim childTable2 = Me.CreateTable("ChildTable2", "ForeignKey", Me.GetParentIds(childTable1))
        Me.DataSet.Tables.Add(childTable2)
		Me.DataSet.Relations.Add(New DataRelation("Parent-Child2", childTable1.Columns("Id"), childTable2.Columns("ForeignKey")))

		Dim childTable3 = Me.CreateTable("ChildTable3", "ForeignKey", Me.GetParentIds(childTable2))
        Me.DataSet.Tables.Add(childTable3)
		Me.DataSet.Relations.Add(New DataRelation("Parent-Child3", childTable2.Columns("Id"), childTable3.Columns("ForeignKey")))
	End Sub

	Public Property DataSet() As DataSet
		Get
			Return m_DataSet
		End Get
		Set
			m_DataSet = Value
		End Set
	End Property
	Private m_DataSet As DataSet

	Private Function GetParentIds(parentTable As DataTable) As IList(Of Integer)
		Return parentTable.AsEnumerable().[Select](Function(r) Convert.ToInt32(r("Id"))).ToList()
	End Function

	Private Function CreateTable(tableName As String, Optional foreignKey As String = Nothing, Optional parentIds As IList(Of Integer) = Nothing) As DataTable
		Dim dataTable = New DataTable(tableName)
		dataTable.Columns.Add(New DataColumn("Id", GetType(Integer)))
		dataTable.Columns.Add(New DataColumn("SomeColumn", GetType(String)))
		dataTable.PrimaryKey = New DataColumn() { dataTable.Columns("Id") }

		If Not String.IsNullOrWhiteSpace(foreignKey) Then
			dataTable.Columns.Add(New DataColumn(foreignKey, GetType(Integer)))
		End If

		If String.IsNullOrWhiteSpace(foreignKey) AndAlso parentIds Is Nothing Then
			For i As Integer = 1 To 10
				dataTable.Rows.Add(i, "Some column")
			Next
		Else
			For i As Integer = 1 To 10
				dataTable.Rows.Add(i, "Some column", parentIds(Me.GetRandomParentKey(parentIds)))
			Next
		End If

		Return dataTable
	End Function

	Private Function GetRandomParentKey(parentIds As IList(Of Integer)) As Integer
		Return randomGenerator.[Next](parentIds.Count)
	End Function
End Class